import { Paging, Room, SurgeryRoom } from "entity";
import { NextFunction, Response } from "express";
import { Request } from "express-jwt";
import Joi from "joi";
import { ILogObj, Logger } from "tslog";
import CommonHelper from "../helpers/common";
import { ReturnHelper } from "../helpers/express/return";
import { OrmHelper } from "../helpers/orm";
import { Language } from "../langs/lang";
import { RoomModel } from "../model/room";
import { SurgeryRoomModel } from "../model/surgery_room";

const log: Logger<ILogObj> = new Logger({
    name: "[SurgeryRoomController]",
    type: "pretty",
});

export class SurgeryRoomController {
    static async list(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
        /*
    #swagger.tags = ['Surgery Room']
    #swagger.security = [{
      "bearerAuth": []
    }]    
    #swagger.parameters['filter'] = {
      description:'',
      in: 'query',
      type: 'string'
    }
    #swagger.parameters['limit'] = {
      in: 'query',
      required: true,
      type: 'number'
    }
    #swagger.parameters['page'] = {
      in: 'query',
      required: true,
      type: 'number'
    }
    #swagger.parameters['with_deleted'] = {
      in: 'query',
      required: true,
      type: 'boolean'
    }
    #swagger.parameters['order_field'] = {
      in: 'query',
      required: true,
      type: 'string'
    }
    #swagger.parameters['order_direction'] = {
      in: 'query',
      required: true,
      schema: {
      '@enum': ['ASC', 'DESC']
      }
    }
    */

        try {
            const schema = Joi.object().keys({
                filter: Joi.string().allow("").optional().label("Filter"),
                page: Joi.number().required().min(1).label("Page"),
                limit: Joi.number().required().min(1).label("Limit"),
                with_deleted: Joi.bool().required().label("With Deleted"),
                order_field: Joi.string().required().label("Order Field"),
                order_direction: Joi.string().allow("asc", "desc").required().label("Order Direction"),
            });

            const param: Paging = await schema.validateAsync(req.query);
            const offset = (param.page - 1) * param.limit;
            const filter = JSON.parse(param.filter);
            const query = await SurgeryRoomModel.list(filter);
            const limit = param.limit;

            const res_count = query;
            const res_list = query
                .leftJoinAndSelect("SurgeryRoom.room", "room")
                .leftJoinAndSelect("room.serviceclass", "service_class")
                .orderBy("SurgeryRoom." + param.order_field, param.order_direction)
                .offset(offset)
                .limit(limit);

            if (param.with_deleted) {
                res_count.withDeleted();
                res_list.withDeleted();
            }

            const current_page = param.page;
            const total_count_data = await res_count.getCount();
            const list_data = await res_list.getMany();
            const count_data = CommonHelper.countObject(list_data);

            return ReturnHelper.successResponselist(res, 200, Language.lang.success_view, count_data, current_page, total_count_data, list_data);
        } catch (e: unknown) {
            log.error(e);
            const err = e as Error;

            return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_view, err.message);
        }
    }

    static async create(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
        /*
          #swagger.tags = ['Surgery Room']
          #swagger.security = [{
            "bearerAuth": []
          }]
          #swagger.requestBody = {
            required: true,
            content: {
              "application/json": {
                schema: {
                  $ref: "#/components/schemas/surgery_room"
                }  
              }
            }
          }
        */

        try {
            const schema = Joi.object().keys({
                room_id: Joi.string().uuid().required().label("Room ID"),
                name: Joi.string().required().label("Name"),
            });

            const param = await schema.validateAsync(req.body);

            let room: Room = await RoomModel.list({ id: param.room_id }).then((q) => q.getOne());
            if (!room) throw { message: "Room " + Language.lang.failed_not_found };

            const data = new SurgeryRoom();
            data.room = room;
            data.name = param.name;
            data.created_by = req.auth?.data.name;

            await OrmHelper.DB.manager.save(data);

            return ReturnHelper.successResponseAny(res, 200, Language.lang.success_insert, data);
        } catch (e: unknown) {
            log.error(e);
            const err = e as Error;

            return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_insert, err.message);
        }
    }

    static async detail(req: Request, res: Response, next: NextFunction): Promise<Response> {
        /*
        #swagger.tags = ['Surgery Room']
        #swagger.security = [{
            "bearerAuth": []
        }]
        #swagger.parameters['id'] = {
            in: 'path',
            description: 'Surgery Room ID.',
            required: true,
            type: 'string'
        }
        */

        try {
            const schema = Joi.object().keys({
                id: Joi.string().required().label("ID"),
            });

            let param: any = await schema.validateAsync(req.params);

            let data = await SurgeryRoomModel.list({ "SurgeryRoom.id": param.id }).then((q) =>
                q //
                    .leftJoinAndSelect("SurgeryRoom.room", "room")
                    .getOne(),
            );

            if (!data) throw { message: "Surgery Room " + Language.lang.failed_not_found };

            return ReturnHelper.successResponseAny(res, 200, Language.lang.success_view, data);
        } catch (e: unknown) {
            log.error(e);
            const err = e as Error;

            return ReturnHelper.errorResponse(res, 500, 402, Language.lang.failed_view, err.message);
        }
    }

    static async update(req: Request, res: Response, next: NextFunction): Promise<void | Response> {
        /*
      #swagger.tags = ['Surgery Room']
      #swagger.security = [{
        "bearerAuth": []
      }]
      #swagger.parameters['id'] = {
        description:'',
        in: 'path',
        type: 'string'
      }
        #swagger.requestBody = {
          required: true,
          content: {
            "application/json": {
              schema: {
                $ref: "#/components/schemas/surgery_room"
              }  
            }
          }
        }
    */

        const queryRunner = OrmHelper.DB.createQueryRunner();
        await queryRunner.startTransaction();

        try {
            req.body.id = req.params["id"];

            const schema = Joi.object().keys({
                id: Joi.string().required().label("Surgery Room ID"),
                room_id: Joi.string().uuid().required().label("Room ID"),
                name: Joi.string().required().label("Name"),
            });

            let param: any = await schema.validateAsync(req.body);

            let surgeryRoom: SurgeryRoom = await SurgeryRoomModel.list({ id: param.id }).then((q) => q.getOne());
            if (!surgeryRoom) throw { message: "Surgery Room " + Language.lang.failed_not_found };

            let room: Room = await RoomModel.list({ id: param.room_id }).then((q) => q.getOne());
            if (!room) throw { message: "Room " + Language.lang.failed_not_found };

            surgeryRoom.room = room;
            surgeryRoom.name = param.name;
            surgeryRoom.updated_by = req.auth?.data.name;

            await queryRunner.manager.save(surgeryRoom);

            await queryRunner.commitTransaction();

            return ReturnHelper.successResponseAny(res, 200, Language.lang.success_update, surgeryRoom);
        } catch (e: unknown) {
            await queryRunner.rollbackTransaction();
            log.error(e);
            const err = e as Error;
            return ReturnHelper.errorResponse(res, 400, 401, Language.lang.failed_view, err.message);
        } finally {
            await queryRunner.release();
        }
    }

    static async delete(req: Request, res: Response, next: NextFunction): Promise<Response> {
        /*
      #swagger.tags = ['Surgery Room']
      #swagger.security = [{
        "bearerAuth": []
      }]
      #swagger.parameters['id'] = {
        in: 'path',
        description: 'Surgery Room ID.',
        required: true,
        type: 'string'
      }
      #swagger.parameters['hard'] = {
        in: 'path',
        description: 'Is Hard Delete',
        required: false,
        type: 'boolean'
      }
    */
        try {
            const schema = Joi.object().keys({
                id: Joi.string().uuid().required().label("ID"),
                hard: Joi.bool().optional().allow("").label("Is hard delete?"),
            });

            const param: { id: string; hard: boolean } = await schema.validateAsync(req.params);

            const repo = OrmHelper.DB.getRepository(SurgeryRoom);

            const affected = (!param.hard ? await repo.softDelete({ id: param.id }) : await repo.delete({ id: param.id })).affected ?? 0;

            if (affected > 0) {
                return ReturnHelper.successResponseAny(res, 200, Language.lang.success_delete, {});
            } else {
                return ReturnHelper.errorResponse(res, 404, 401, Language.lang.failed_not_found, "");
            }
        } catch (e: unknown) {
            log.error(e);
            const err = e as Error;

            return ReturnHelper.errorResponse(res, 500, 402, Language.lang.failed_delete, err.message);
        }
    }
}
